// Generated by CoffeeScript 1.6.2
(function() {
  var PriorityQueue, Trampoline, debug;

  PriorityQueue = require("./priority_queue").PriorityQueue;

  debug = require("./debugging").debug;

  Trampoline = (function() {
    function Trampoline() {
      this.work = new PriorityQueue();
      this.cache = {};
    }

    Trampoline.prototype.push = function(priority, description, job) {
      var _this = this;

      this.work.put({
        description: description,
        job: job
      }, priority);
      return debug(function() {
        var item;

        return "(+) push work to trampoline. new contents:\n" + ((function() {
          var _i, _len, _ref, _results;

          _ref = this.work.queue;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            item = _ref[_i];
            _results.push("( ) " + item.priority + " - " + (item.item.description()) + "\n");
          }
          return _results;
        }).call(_this)) + "(.)";
      });
    };

    Trampoline.prototype.size = function() {
      return this.work.length();
    };

    Trampoline.prototype.next = function() {
      var item;

      item = this.work.get();
      if (item != null) {
        return item.job();
      }
    };

    Trampoline.prototype.ready = function() {
      return !this.work.isEmpty();
    };

    Trampoline.prototype.getCache = function(parser, state) {
      var entry, x;

      x = this.cache[parser.id];
      if (x == null) {
        this.cache[parser.id] = x = {};
      }
      entry = x[state.pos];
      if (entry == null) {
        x[state.pos] = entry = {
          continuations: [],
          results: []
        };
      }
      return entry;
    };

    return Trampoline;

  })();

  exports.Trampoline = Trampoline;

}).call(this);
